.\"	$NetBSD: _lwp_detach.2,v 1.3 2007/02/10 10:34:03 ad Exp $
.\"
.\" Copyright (c) 2003, 2007 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe of Wasabi Systems, Inc, and by Andrew Doran.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd January 20, 2007
.Dt _LWP_DETACH 2
.Os
.Sh NAME
.Nm _lwp_detach
.Nd detach a light-weight process
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In lwp.h
.Ft int
.Fn _lwp_detach "lwpid_t lwp"
.Sh DESCRIPTION
.Fn _lwp_detach
causes a light-weight process to become detached, having the same
effect as if the LWP was created with the
.Dv LWP_DETACHED
flag.
.Pp
The resources associated with a detached LWP will be automatically
reclaimed by the system when the LWP exits.
Conversely, an attached LWP's resources will not be reclaimed until
its status is reported to another LWP via
.Xr _lwp_wait 2 .
.Sh RETURN VALUES
A 0 value indicates that the call succeeded.
A \-1 return value indicates an error occurred and
.Va errno
is set to indicate the reason.
.Sh ERRORS
.Bl -tag -width [EINVAL]
.It Bq Er EINVAL
The LWP is already detached.
.It Bq Er ESRCH
No LWP can be found in the current process corresponding to that
specified by
.Fa lwp .
.El
.Sh SEE ALSO
.Xr _lwp_create 2 ,
.Xr _lwp_wait 2
.Sh HISTORY
The
.Fn _lwp_detach
system call first appeared in
.Nx 5.0 .
